<?php
namespace komaphp\base;

use komaphp\core\Session as Session;
use komaphp\core\Helper as Helper;
abstract class Controller
{
    /**
     * Getメソッド（強制）画面表示
     */
    abstract protected function get();

    /**
     * Postメソッド（強制）POST送信
     * Input::get({コントロール名})またはInput::all()でPOST値(FILES,REQUESTも)を取得可能
     */
    abstract protected function post();

    public $prop = [];

    function __set(string $name,$value =null){
        $this->prop[$name] = $value;
    }
    function __get(string $name){
        return $this->prop[$name];
    }

    //ログインしているかチェック
    function auth(){
        return ((is_null(Session::get("login")) || !Session::get("login"))) ? Helper::redirect('Login?timeout=1'):true; //未ログインはログイン画面へ
    }
}