<?php
namespace komaphp\core;

/**
 * [Core]Config：設定取得コントローラ
 * 指定に応じて設定ファイルより設定を取得する
 */
class Config{

    /**
     *
     * @param string $name
     * @param string $setting
     * @return null,[],string
     */
    public static function get(string $name=null ,string $setting=null,$default=null){
        if(is_null($name) || $name == "") return null;
        $confFileName = Dir::config_path().DS."{$name}.php";

        if(!file_exists($confFileName)){
            return $default;
        }

        $conf = require $confFileName;
        if(is_null($setting) || $setting == ""){
            return $conf;
        }

        $confset = explode(".",$setting);

        $cnt = 0;
        $conff = $default;
        foreach($confset as $k){
            if($cnt == 0){
                if(Helper::ak($k, $conf)){
                    $conff = $conf[$k];
                }
            }else{
                if(Helper::ak($k, $conff)){
                    $conff = $conff[$k];
                }else{
                    $conff = null;
                }
            }
            $cnt++;
        }

        return $conff;

    }
}