<?php
namespace komaphp\core;

use komaphp\core\Config as Config;
/**
 * [Core]Input：入力フォーム送信情報取得クラス
 * POST/FILESのエイリアスクラス
 */
class Input{
	/**
	 * @param string $name
	 * @return string|NULL
	 */
    public static function get(string $name,string $filter=FILTER_DEFAULT ){
        return filter_input(INPUT_POST,$name,$filter);
	}
	/**
	 */
	public static function all(){
	    return filter_input_array(INPUT_POST);
	}

	public static function getFromInput(string $form_name = ''){
	    if(empty($form_name)) return null;
        $input_setting = Config::get('input',$form_name);
        $get_post_data = [];

        foreach($input_setting as $clm_name=>$d){
            $get_post_data[$clm_name] = self::get($d['name']);
        }
        return $get_post_data;
	}
	public static function getFromSearch(string $form_name = ''){
	    if(empty($form_name)) return null;
	    $input_setting = Config::get('search',$form_name);
	    $get_post_data = [];

	    foreach($input_setting as $clm_name=>$d){
	        $val = self::get($d['name']);
	        if(!is_null($val) && !empty(self::get($d['name']))){
	            $get_post_data[$clm_name] = $val;
	        }
	    }
	    return $get_post_data;
	}


}