<?php
namespace komaphp\fwboar\controllers\ajax;

use komaphp\base as base;
use komaphp\core\Validation as Validation;
use komaphp\core\Config as Config;
use komaphp\core\Input as Input;
use komaphp\core\Log as Log;
use komaphp\core\Session as Session;
use komaphp\core\Helper as Helper;
use komaphp\db as db;
use komaphp\fwboar\umodel\master\User as User;

class AuthController extends base\Controller{

    function get($request = [])
    {
        Session::destroy();
        Session::start();

        return ['result'=>0];
    }

    function post(array $request = [], array $route=[]):array
    {
        //ログアウトはセッション破棄して終わり
        if($route['action'] === 'logout'){
            sleep(1);
            Session::destroy();
            Session::start();
            return ['result'=>0];
        }

        if($route['action'] === 'login'){
            $user = new User();
            $w = [
                'login_id'=>Input::get('login_id'),
                'password'=> hash(Config::get("app","hash_key"),Config::get('database','prefix').'_'.Input::get("password")),
            ];
        }

        $d = $user->getOneInfo([],$w);

        $result = [];
        $result['result'] = 0;
        //認証結果
        if(count($d) === 0){
            $result['result'] = 1;
            $result['login_error'] = true;
            $result['login_error_msg'] = Config::get('message','login');
            $w = [
                'login_id'=>Input::get('login_id'),
            ];
            $d = $user->getOneInfo([],$w);
            //アカウントが存在する場合はロックカウント＋する
            /*if(count($d) > 0){
                if(($d['lockcnt']+1) > Config::get('app','lockcnt')){
                    $this->param['loginerror'] = null;
                    $this->param['lockerror'] = true;
                    $where = [
                        'user_id'=>$d['user_id']
                    ];
                    $add = [
                        'user_id'=>$d['user_id']
                        ,'lockcnt'=>$d['lockcnt']+1
                    ];
                    $user->update('user_id',$add,$where);
                    Log::set('Locked Login :LockError');
                }else{
                    $where = [
                        'user_id'=>$d['user_id']
                    ];
                    $add = [
                        'user_id'=>$d['user_id']
                        ,'lockcnt'=>$d['lockcnt']+1
                    ];
                    $user->update('user_id',$add,$where);
                    Log::set('Locked LoginID:'.Input::get('login_id').' Cnt:'.($d['lockcnt']+1));
                }
            }*/
        }else{
            //ロック中はログインさせない
            if($d['lockcnt'] >= Config::get('app','lockcnt')){
                Log::set('Locked Login :LockError');
                $result['lockerror'] = true;
            }else{
                //sleep(1); //ローディングバーのための待機
                $result['loginerror'] = false;
                Session::reg_id();

                Session::set('UserInfo',$d);
                Session::set('login',true);
                Session::set('last_action',time());
                Session::set('auth',$d['auth_cd']);

                //最終ログイン日時を更新
                $where = [
                    'user_id'=>$d['user_id']
                ];
                $add = [
                    'user_id'=>$d['user_id']
                    ,'last_logindate'=>date('Y-m-d H:i:s')
                    ,'lockcnt'=>0
                ];//ログイン成功したら0に
                $user->update('user_id',$add,$where);
                Log::set('Login');
            }
        }

        return $result;
    }
}